# Pantera - Web Pen-Test Proxy
#
# FILENAME      : panteraImportExport.py
# CODER         : Simon Roses Femerling
# DATE          : 11/08/2006
# LAST UPDATE   : 11/08/2006
# ABSTRACT      : Python Web Pen-Test Proxy :)
#                 Pantera Import Export Class for plugins
#
# - Roses Labs Innovations (RL+I)
# Roses Labs
# http://www.roseslabs.com
#
# Copyright (c) 2003-2006 Roses Labs.
#
# You may not distribute, transmit, repost this software for commercial 
# purposes without Roses Labs written permission. 
#
# Permission is hereby granted, free of charge, to any person obtaining
# a copy of this software and associated documentation files (the
# "Software"), to deal in the Software without restriction, including
# without limitation the rights to use, copy, modify, publish,
# distribute the Software, and to permit persons to whom the Software 
# is furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included
# in all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
# EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
# MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
# IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
# CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
# TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
# SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
#

'''
@author:       Simon Roses Femerling
@license:      GNU General Public License 2.0 or later
@contact:      pantera.proxy@gmail.com
@organization: OWASP / Roses Labs
'''

import panterautils
import pantera
import sys
import os
import imp

#############################################################################################
# Our Functions
#############################################################################################

class PIE:
    
    #############################################################################################
    # FUNC     : 
    # PARAMS   : 
    # RETURN   : 
    # ABSTRACT :         
    def __init__(self):
        '''
        Init class.
        '''
        self.iClear()

    #############################################################################################
    # FUNC     : 
    # PARAMS   : string
    # RETURN   : file pointer
    # ABSTRACT : Open a binary file
    def iClear(self):
        '''
    
        '''
        self.error_msg = ""
        self.filename = ''
        self.fp = None
        self.registerRequestandResponse = None
        self.current_project_id = None
        self.pan_db = None
        self.plugin_options = {}
        self.pf = None
    
    #############################################################################################
    # FUNC     : 
    # PARAMS   : string
    # RETURN   : file pointer
    # ABSTRACT : Open a binary file
    def GetErroMsg(self):
        '''
    
        '''
        return self.error_msg

    #############################################################################################
    # FUNC     : 
    # PARAMS   : string
    # RETURN   : file pointer
    # ABSTRACT : Open a binary file
    def SetErrorMsg(self,m):
        '''
    
        '''
        self.error_msg = m

    def SetFilename(self, f):
        '''
    
        '''
        self.filename = f
        
    def ReturnFilename(self):
        '''
    
        '''
        return self.filename
    
    def ReturnFilePointer(self):
        '''
    
        '''
        return self.fp

    def OpenFile(self,mode='r'):
        '''
    
        '''
        self.fi_dir = panterautils.pathjoin(os.getcwd(),"PanteraData","import_export",self.filename)
        try:
            self.fp=open(self.fi_dir,mode)
        except IOError,e:
            er = ""
            er += "IE Error: Opening file %s\r\n" % self.filename
            er += "%s" % e
            self.SetErrorMsg(er)
            return -1
        return 0

    def CloseFile(self):
        '''
    
        '''
        try:
            self.fp.close()
        except IOError,e:
            er = ""
            er += "IE Error: Close file %s\r\n" % self.filename
            er += "%s" % e
            self.SetErrorMsg(er)
            return -1
        return 0
            
    def WriteData(self, d):
        '''
    
        '''
        l = len(d)
        try:
            self.fp.write(d)
            self.fp.flush()
        except IOError,e:
            er = ""
            er += "IE Error: Write to file %s\r\n" % self.filename
            er += "%s" % e
            self.SetErrorMsg(er)
            return -1
        return l
        
    def ReadEntireFile(self):
        '''
        
        '''
        d = ''
        try:
            for line in self.fp.readline():
                d += line
        except IOError,e:
            er = ""
            er += "IE Error: Read file %s\r\n" % self.filename
            er += "%s" % e
            self.SetErrorMsg(er)
        return d
       
    def ReadFileIntoList(self):
        d = []
        try:
            d = self.fp.readlines()
        except IOError,e:
            er = ""
            er += "IE Error: Read file %s\r\n" % self.filename
            er += "%s" % e
            self.SetErrorMsg(er)
        return d
    
    def RegisteriData(self, d):
        if d.has_key('self.registerRequestandResponse'):
            self.registerRequestandResponse = d['self.registerRequestandResponse']
        if d.has_key('current_project_id'):
            self.current_project_id = d['current_project_id']
        if d.has_key('pan_db'):
            self.pan_db = d['pan_db']
        if d.has_key('options'):
            self.plugin_options = d['options']
        if d.has_key('pf'):
            self.pf = d['pf']
        
    def GetregisterRequestandResponse(self):
        return self.registerRequestandResponse
    
    def Getcurrent_project_id(self):
        return self.current_project_id
    
    def GetDBcon(self):
        return self.pan_db
    
    def DoRequestResponse(self, request_buf='', response_buf=''):
        self.client_header = pantera.HTTPHeader()
        self.client_body = pantera.HTTPBody()
        self.server_header = pantera.HTTPHeader()
        self.server_body = pantera.HTTPBody()        
        
        i = 0
        while self.client_header.isdone()==0:
            data = request_buf[i]
            
            if not data:
                break
            self.client_header.addData(data)    
            i += 1
        
        if self.client_header.gotGoodHeader():
                if self.client_header.bodySize()>0:
                    self.client_body.readOffline(request_buf[i:],self.client_header.bodySize(),0)

        #reset this to the truth
        self.client_header.mybodysize=self.client_body.mysize
                
        #Do response
        i = 0
        while self.server_header.isdone()==0:
            data = response_buf[i]
            if not data:
                break
            self.server_header.addData(data)    
            i += 1
        
        if self.server_header.gotGoodHeader():
                if self.server_header.bodySize()>0:
                    self.server_body.readOffline(response_buf[i:],self.server_header.bodySize(),0)

        #reset this to the truth
        self.server_header.mybodysize=self.server_body.mysize
        
        return self.client_header, self.client_body, self.server_header, self.server_body         
    
    def InsertIntoFramework(self, request_buf='', response_buf=''):
        self.client_header, self.client_body, self.server_header, self.server_body = self.DoRequestResponse(request_buf, response_buf)
        
        # Insert into framework
        self.registerRequestandResponse(self.client_header, self.client_body, self.server_header, self.server_body)
    
    def SetOptions(self,o):
        self.plugin_options = o
        
    def GetOptions(self):
        return self.plugin_options
        
    def ReturnServerBody(self,f):
        return self.pf.ReturnPageBody(f)

    def ReturnClientHeader(self,f):
        return self.pf.ReturnClientHeader(self.pf.displayClientHeader(f))
        
    def ReturnServerHeader(self,f):
        return self.pf.JustResponseHeader(f)
        
    def ReturnClientBody(self, f):
        cb = self.pf.displayClientBody(f)
        if len(cb.data)>0:
            return "".join(cb.data)
        else:
            return ''
        
    def CreateOptionForm(self):
        pass
        
    def InitIE(self):
        pass
        
    def BeginIE(self):
        pass

# RL+I EOF