# Pantera - Web Pen-Test Proxy
#
# FILENAME      : panteraStatus.py
# CODER         : Simon Roses Femerling
# DATE          : 11/25/2006
# LAST UPDATE   : 11/25/2006
# ABSTRACT      : Pantera Response Manipulator Class
#       
# - Roses Labs Innovations (RL+I)
# Roses Labs
# http://www.roseslabs.com
#
# Copyright (c) 2003-2006 Roses Labs.
#
# You may not distribute, transmit, repost this software for commercial 
# purposes without Roses Labs written permission. 
#
# Permission is hereby granted, free of charge, to any person obtaining
# a copy of this software and associated documentation files (the
# "Software"), to deal in the Software without restriction, including
# without limitation the rights to use, copy, modify, publish,
# distribute the Software, and to permit persons to whom the Software 
# is furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included
# in all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
# EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
# MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
# IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
# CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
# TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
# SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
#

'''
@author:       Simon Roses Femerling
@license:      GNU General Public License 2.0 or later
@contact:      pantera.proxy@gmail.com
@organization: OWASP / Roses Labs
'''

import re
import sys
import os
import imp
import htmldata
import panteraFile

#############################################################################################
# Classes
#############################################################################################

#############################################################################################
# FUNC     : class PanteraResponse
# PARAMS   : ...
# RETURN   : ...
# ABSTRACT : 
class PanteraResponse:
    '''
    Pantera Respose Manipulator Class.
    '''
    
    #############################################################################################
    # FUNC     : def __init__
    # PARAMS   : ...
    # RETURN   : ...
    # ABSTRACT : Init 
    def __init__(self):
        '''
        Init class.
        '''
        self.iClear()
    # EOF: def __init__
        
    def iClear(self):
        # status variables
        self.error_msg = ''
        self.pf = None
        self.htmldata_p = None
        self.replace_uri = 'yes'
        self.header = None
        self.body = None
        self.url = ''
                
   #############################################################################################
    # FUNC     : 
    # PARAMS   : 
    # RETURN   : 
    # ABSTRACT : 
    def GetErroMsg(self):
        '''
    
        '''
        return self.error_msg

    #############################################################################################
    # FUNC     : 
    # PARAMS   : 
    # RETURN   : 
    # ABSTRACT : 
    def SetErrorMsg(self,m):
        '''
    
        '''
        self.error_msg = m
        
    def SetReplaceURI(self, u='yes'):
        if u != 'yes' or u != 'no':
            u = 'yes'
        self.replace_uri = u
                    
    def GetReplaceURI(self):
        return self.replace_uri
    
    def ImportPanteraFile(self):
        self.pf = panteraFile.PanteraFile()

    def SetPanteraFile(self,p):
        self.pf = p

    def SetURL(self,u):
        self.url = u
        
    def GetURL(self):
        return self.url
    
    def GetResponse(self, file):
        self.data = ''
        
        if self.pf == None:
            self.ImportPanteraFile()
        
        self.header = self.pf.JustResponseHeader(file)
        self.body = self.pf.ReturnPageBody(file)
            
        #self.data = self.pf.displayResponse(file)
        if self.data == '':
            self.SetErrorMsg(self.pf.GetErroMsg())
      
        if self.replace_uri == 'yes':
            self.dat = htmldata.urlextract(self.body,self.url)
            self.body = htmldata.urljoin(self.body,self.dat)
        
        self.data = self.header
        #self.data += '\r\n'
        self.data += self.body
        
        return self.data
    
# RL+I EOF