# Pantera Import Export Plugin - Text Export
#
# FILENAME      : text_export.py
# CODER         : Simon Roses Femerling
# DATE          : 11/23/2006
# LAST UPDATE   : 11/23/2006
# ABSTRACT      : Export data to file in txt format
#       
# - Roses Labs Innovations (RL+I)
# Roses Labs
# http://www.roseslabs.com
#
# Copyright (c) 2003-2006 Roses Labs.
#
# You may not distribute, transmit, repost this software for commercial 
# purposes without Roses Labs written permission. 
#
# Permission is hereby granted, free of charge, to any person obtaining
# a copy of this software and associated documentation files (the
# "Software"), to deal in the Software without restriction, including
# without limitation the rights to use, copy, modify, publish,
# distribute the Software, and to permit persons to whom the Software 
# is furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included
# in all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
# EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
# MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
# IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
# CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
# TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
# SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
#

'''
@author:       Simon Roses Femerling
@license:      GNU General Public License 2.0 or later
@contact:      pantera.proxy@gmail.com
@organization: OWASP / Roses Labs
'''

from panteraImportExport import PIE
import panteraForms
import re
import string

plugin_info =  {'id':'TextExport',
                'desc':'Export result to text file.',
                'author':'Simon Roses Femerling',
                'email':'sroses@roseslabs.com',
                'version':'0.1',
                'options':'yes',
                'type':'export'  # import or export type
                } 

class TextExport(PIE):
    '''
    TextExport class.
    '''
    
    def InitIE(self):
        '''
        Init function.
        '''
        PIE.__init__(self)
        return 0
        
    def CreateOptionForm(self):
        form = ''
        plugin_form = panteraForms.PanteraForms()
        
        form += "%s\r\n" % plugin_form.layout.entry(
            content=plugin_form.field.text("result_name",""),   
            name='Result')   
        form += "%s\r\n" % plugin_form.layout.entry(
            content=plugin_form.field.text("result_op",""),   
            name='Result')   
        return form
        
    def BeginIE(self):
        '''
        Begin function.
        '''
        #print self.GetOptions()
        db = self.GetDBcon()
        print db.ReturnLastRows(self.Getcurrent_project_id())
        
        return 0
    
# RL+I EOF